ru.bitel.bgbilling.modules.drwebn.server.bean

## Class AgentAVDManager

- java.lang.Object
- - ru.bitel.common.dao.AbstractDao<B>
  - - ru.bitel.common.dao.AbstractIdDao<AgentAVD>
    - - ru.bitel.bgbilling.modules.drwebn.server.bean.AgentAVDManager

- All Implemented Interfaces:
    java.lang.AutoCloseable

      public class AgentAVDManager
      extends ru.bitel.common.dao.AbstractIdDao<AgentAVD>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ru.bitel.common.dao.AbstractDao

      `ru.bitel.common.dao.AbstractDao.ResultSetIterator`

  - ### Field Summary

    - ### Fields inherited from class ru.bitel.common.dao.AbstractDao

      `cacheFilter, cacheJoin, cacheOrderBy, cachePaged, cachePS, cacheWhat, con, getByIdPS, logger, mid, moduleId, orderByPattern, SQL_CALC_FOUND_ROWS, SQL_DELETE, SQL_EQ, SQL_EQCS, SQL_FROM, SQL_GROUP, SQL_IN, SQL_INSERT, SQL_LIMIT, SQL_ORDER, SQL_SELECT, SQL_SET, SQL_UPDATE, SQL_WHERE, tableName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AgentAVDManager(java.sql.Connection con, int mid)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `changeStatus(AgentAVDStatus newStatus, java.lang.Integer userId)`
    `int` | `getActualAgentCount(int cid)`
    `protected int` | `getAgentCount(int cid)`
    `java.util.List<AgentAVD>` | `getAgentListAll()`
    `java.util.List<AgentAVD>` | `getAgentListById(int cid)`
    `protected AgentAVD` | `getFromRS(java.sql.ResultSet rs)`
    `java.util.List<AgentAVDStatus>` | `getStatusList(int agentId)`
    `java.util.List<AgentAVDStatus>` | `getStatusList(int agentId, java.util.Date date)` Список статусов с датой окончания пустой либо большей или равной параметру date
    `java.util.List<AgentAVDStatus>` | `getStatusList(int agentId, java.util.Date date1, java.util.Date date2, int status)` Список статусов текущем месяце даты date
    `java.util.List<AgentAVDStatus>` | `getStatusListForDate(java.util.Date date)`
    `java.util.List<AgentAVDStatusLog>` | `getStatusListLog(int agentId)`
    `static boolean` | `isStatusPeriodValid(AgentAVDStatus status)`
    `protected void` | `updateImpl(AgentAVD agent)` Этот метод каждый реализует сам со своей логикой.

    - ### Methods inherited from class ru.bitel.common.dao.AbstractIdDao

      `delete, get, getAndDelete, getAndUpdate`

    - ### Methods inherited from class ru.bitel.common.dao.AbstractDao

      `close, delete, deleteImpl, eq, get, getById, getImpl, getListFromRS, getSQLOrder, getSQLOrder, getTableName, list, list, listImpl, listImpl, listImplPS, listImplPS, processException, recycle, setStatementParam, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AgentAVDManager

          public AgentAVDManager(java.sql.Connection con,
                                 int mid)

  - ### Method Detail

    - #### getFromRS

          protected AgentAVD getFromRS(java.sql.ResultSet rs)
                                throws java.sql.SQLException

      Specified by:
        `getFromRS` in class `ru.bitel.common.dao.AbstractDao<AgentAVD>`
      Throws:
        `java.sql.SQLException`

    - #### updateImpl

          protected void updateImpl(AgentAVD agent)
                             throws ru.bitel.bgbilling.common.BGException,
                                    java.sql.SQLException

      Description copied from class: `ru.bitel.common.dao.AbstractDao`
      Этот метод каждый реализует сам со своей логикой.
      Для обновления вызывать update.
      Specified by:
        `updateImpl` in class `ru.bitel.common.dao.AbstractDao<AgentAVD>`
      Parameters:
        `agent` - экземпляр модели
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки
        `java.sql.SQLException` - ошибки

    - #### getAgentListById

          public java.util.List<AgentAVD> getAgentListById(int cid)
                                                    throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getAgentListAll

          public java.util.List<AgentAVD> getAgentListAll()
                                                   throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getAgentCount

          protected int getAgentCount(int cid)
                               throws ru.bitel.bgbilling.common.BGException,
                                      java.sql.SQLException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.sql.SQLException`

    - #### getActualAgentCount

          public int getActualAgentCount(int cid)
                                  throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getStatusList

          public java.util.List<AgentAVDStatus> getStatusList(int agentId)
                                                       throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getStatusListLog

          public java.util.List<AgentAVDStatusLog> getStatusListLog(int agentId)
                                                             throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getStatusList

          public java.util.List<AgentAVDStatus> getStatusList(int agentId,
                                                              java.util.Date date)
                                                       throws java.sql.SQLException

      Список статусов с датой окончания пустой либо большей или равной параметру date
      Parameters:
        `agentId` - id агента
        `date` - дата
      Returns:
      Throws:
        `java.sql.SQLException`

    - #### getStatusList

          public java.util.List<AgentAVDStatus> getStatusList(int agentId,
                                                              java.util.Date date1,
                                                              java.util.Date date2,
                                                              int status)
                                                       throws java.sql.SQLException

      Список статусов текущем месяце даты date
      Parameters:
        `agentId` - id агента
        `date` - дата
      Returns:
      Throws:
        `java.sql.SQLException`

    - #### getStatusListForDate

          public java.util.List<AgentAVDStatus> getStatusListForDate(java.util.Date date)
                                                              throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### changeStatus

          public void changeStatus(AgentAVDStatus newStatus,
                                   java.lang.Integer userId)
                            throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### isStatusPeriodValid

          public static boolean isStatusPeriodValid(AgentAVDStatus status)